
module MultiplesBCD(
//	input [3:0] hex_digit,
	output reg [6:0] seg_0,
	output reg [6:0] seg_1,
	output reg [6:0] seg_2,
	output reg [6:0] seg_3,
	output reg [6:0] seg_4,
	output reg [6:0] seg_5,
	output reg [6:0] seg_6,
	output reg [6:0] seg_7,
	output reg [7:0] punto,
	
	
	//viene del módulo binary2bcd
	input wire clk,
   input wire [7:0] n,
   input wire start,
   output wire [11:0] bcd,
   output reg finish
	
	);

   reg [3:0] loop = 4'h0;
   reg [19:0] scratch = 20'h00000;
   reg [19:0] scratch_modificado;
   reg [11:0] output_reg = 12'h000;
   assign bcd = output_reg;

   initial finish = 1'b1;
   always @(posedge clk) begin
	punto = ~8'b00000000; //apagamos todos los puntos de los BCD 
      if (start && finish) begin
         loop <= 4'h0;
         scratch <= {12'h000, n};
         finish <= 1'b0;
      end
      else if (loop == 4'd8) begin
         output_reg <= scratch[19:8];
         loop <= loop + 1;
         finish <= 1'b1;
      end
      else if (loop == 4'd9) begin
         finish <= 1'b0;
      end
      else begin
         loop <= loop + 1;
         scratch <= {scratch_modificado[18:0],1'b0};
      end
		
		
		// seg = {6,5,4,3,2,1,0};
		// 0 es encendido y 1 es apagado
		// Creamos los valores de seg_0 y seg_1 de forma simultanea en una sentencia case
			case (output_reg[3:0])
			4'b0000 :  begin seg_0 = ~7'b0111111;	end	// Hexadecimal 0   // ---0----
			4'b0001 :  begin seg_0 = ~7'b0000110; 	end	// Hexadecimal 1   // |      |
			4'b0010 :  begin seg_0 = ~7'b1011011;  end	// Hexadecimal 2   // 5      1
			4'b0011 :  begin seg_0 = ~7'b1001111; 	end	// Hexadecimal 3   // |      |
			4'b0100 :  begin seg_0 = ~7'b1100110; 	end	// Hexadecimal 4   // ---6----
			4'b0101 :  begin seg_0 = ~7'b1101101; 	end	// Hexadecimal 5   // |      |
			4'b0110 :  begin seg_0 = ~7'b1111101; 	end	// Hexadecimal 6   // 4      2
			4'b0111 :  begin seg_0 = ~7'b0000111; 	end	// Hexadecimal 7   // |      |
			4'b1000 :  begin seg_0 = ~7'b1111111;  end	// Hexadecimal 8   // ---3----
			4'b1001 :  begin seg_0 = ~7'b1101111; 	end	// Hexadecimal 9
			4'b1010 :  begin seg_0 = ~7'b1110111; 	end	// Hexadecimal A
			4'b1011 :  begin seg_0 = ~7'b1111100; 	end	// Hexadecimal B
			4'b1100 :  begin seg_0 = ~7'b0111001; 	end	// Hexadecimal C
			4'b1101 :  begin seg_0 = ~7'b1011110; 	end	// Hexadecimal D
			4'b1110 :  begin seg_0 = ~7'b1111001; 	end	// Hexadecimal E
			4'b1111 :  begin seg_0 = ~7'b1110001; 	end	// Hexadecimal F
			endcase	 
		
	case (output_reg[7:4])
			4'b0000 :  begin seg_1 = ~7'b0111111;	end	// Hexadecimal 0   // ---0----
			4'b0001 :  begin seg_1 = ~7'b0000110; 	end	// Hexadecimal 1   // |      |
			4'b0010 :  begin seg_1 = ~7'b1011011;  end	// Hexadecimal 2   // 5      1
			4'b0011 :  begin seg_1 = ~7'b1001111; 	end	// Hexadecimal 3   // |      |
			4'b0100 :  begin seg_1 = ~7'b1100110; 	end	// Hexadecimal 4   // ---6----
			4'b0101 :  begin seg_1 = ~7'b1101101; 	end	// Hexadecimal 5   // |      |
			4'b0110 :  begin seg_1 = ~7'b1111101; 	end	// Hexadecimal 6   // 4      2
			4'b0111 :  begin seg_1 = ~7'b0000111; 	end	// Hexadecimal 7   // |      |
			4'b1000 :  begin seg_1 = ~7'b1111111;  end	// Hexadecimal 8   // ---3----
			4'b1001 :  begin seg_1 = ~7'b1101111; 	end	// Hexadecimal 9
			4'b1010 :  begin seg_1 = ~7'b1110111; 	end	// Hexadecimal A
			4'b1011 :  begin seg_1 = ~7'b1111100; 	end	// Hexadecimal B
			4'b1100 :  begin seg_1 = ~7'b0111001; 	end	// Hexadecimal C
			4'b1101 :  begin seg_1 = ~7'b1011110; 	end	// Hexadecimal D
			4'b1110 :  begin seg_1 = ~7'b1111001; 	end	// Hexadecimal E
			4'b1111 :  begin seg_1 = ~7'b1110001; 	end	// Hexadecimal F
			endcase	
		
	case (output_reg[11:7])
			4'b0000 :  begin seg_2 = ~7'b0111111;	end	// Hexadecimal 0   // ---0----
			4'b0001 :  begin seg_2 = ~7'b0000110; 	end	// Hexadecimal 1   // |      |
			4'b0010 :  begin seg_2 = ~7'b1011011;  end	// Hexadecimal 2   // 5      1
			4'b0011 :  begin seg_2 = ~7'b1001111; 	end	// Hexadecimal 3   // |      |
			4'b0100 :  begin seg_2 = ~7'b1100110; 	end	// Hexadecimal 4   // ---6----
			4'b0101 :  begin seg_2 = ~7'b1101101; 	end	// Hexadecimal 5   // |      |
			4'b0110 :  begin seg_2 = ~7'b1111101; 	end	// Hexadecimal 6   // 4      2
			4'b0111 :  begin seg_2 = ~7'b0000111; 	end	// Hexadecimal 7   // |      |
			4'b1000 :  begin seg_2 = ~7'b1111111;  end	// Hexadecimal 8   // ---3----
			4'b1001 :  begin seg_2 = ~7'b1101111; 	end	// Hexadecimal 9
			4'b1010 :  begin seg_2 = ~7'b1110111; 	end	// Hexadecimal A
			4'b1011 :  begin seg_2 = ~7'b1111100; 	end	// Hexadecimal B
			4'b1100 :  begin seg_2 = ~7'b0111001; 	end	// Hexadecimal C
			4'b1101 :  begin seg_2 = ~7'b1011110; 	end	// Hexadecimal D
			4'b1110 :  begin seg_2 = ~7'b1111001; 	end	// Hexadecimal E
			4'b1111 :  begin seg_2 = ~7'b1110001; 	end	// Hexadecimal F
			endcase		
	
	//Poner a 0 los displays que no se usan temporalmente
	seg_3 = ~7'b0000000;
	seg_4 = ~7'b0000000;
	seg_5 = ~7'b0000000;
	seg_6 = ~7'b0000000;
	seg_7 = ~7'b0000000;
   end

   always @* begin
      scratch_modificado[7:0] = scratch[7:0];
      if (scratch[11:8]>4)
         scratch_modificado[11:8] = scratch[11:8] + 4'd3;
      else
         scratch_modificado[11:8] = scratch[11:8];
      if (scratch[15:12]>4)
         scratch_modificado[15:12] = scratch[15:12] + 4'd3;
      else
         scratch_modificado[15:12] = scratch[15:12];
      if (scratch[19:16]>4)
         scratch_modificado[19:16] = scratch[19:16] + 4'd3;
      else
         scratch_modificado[19:16] = scratch[19:16];
   end


	endmodule

	
	

	
	